#!/bin/bash
#################
#
#

# installer version stuff
SCRIPTVERSION="0.2"
SCRIPTVERSIONSTR="Kommander application installer version $SCRIPTVERSION"
SCRIPTUSSAGE="SCRIPTVERSIONSTR\nUssage: kmdr-app-install.sh [CMD(I|U)] [MODE(S|L)] [DEST_BASE_PATH] [DCOPID]"
SCRIPTDEBUG="1"  # 1 for debug, else no debug



# check arguments relevant for installer
if [ "$#" -eq 1 -a "$1" = "--version" ]; then
  echo -e "$SCRIPTVERSIONSTR\n"
  exit
elif [ "$#" -ne 4 ]; then  
  echo -e "$SCRIPTUSSAGE\n" 
  exit
fi

# get vars for application install 
export COMMONDIR=`dirname $0`
export SDIR="$COMMONDIR/../src"
CMD="$1"
export DDIR="$3"
DCOPID="$4"

if [ "$2" = "S" ]; then
  export SUDO="root"
elif [ -n $USER ]; then
  export SUDO=$USER
else
  export SUDO=$UID
fi

export APPNAME=`dcop $DCOPID KommanderIf global APPNAME`
export APPUNAME=`dcop $DCOPID KommanderIf global APPUNAME`
export APPVERSION=`dcop $DCOPID KommanderIf global APPVERSION`
export APPCAT=`dcop $DCOPID KommanderIf global APPCAT`
export MAIN=`dcop $DCOPID KommanderIf global MAIN`

# TODO: check if dcop was successfull, if not -> exit

export APPDIR="$DDIR/share/apps/kmdr-$APPUNAME"
export APPLNKDIR="$DDIR/share/applnk/$APPCAT"
export KDEBINDIR="$DDIR/bin"

# prepare startup script and desktop file
echo "#!/bin/bash" > $COMMONDIR/$APPUNAME
echo `which kmdr-executor`" $APPDIR/$MAIN">> $COMMONDIR/$APPUNAME
#cat $COMMONDIR/main.sh >> $COMMONDIR/$APPUNAME

TMP=`cat $COMMONDIR/$APPUNAME.desktop | grep -r ^EXEC=`
TMP2="Exec=$KDEBINDIR/$APPUNAME"
cat $COMMONDIR/$APPUNAME.desktop | sed -e"s\\$TMP\\$TMP2\\g" > $COMMONDIR/$APPUNAME.desktop



# be verbose - some debug output
if [ "$SCRIPTDEBUG" = "1" ]; then
  echo "================="
  echo "script parameters"
  echo -e "=================\n"
  echo "src: $SDIR"
  echo "dcop: $DCOPID"
  echo "dest: $DDIR"
  echo "cmd: $CMD"
  echo "user: $SUDO"
  echo "name: $APPNAME"
  echo "uname: $APPUNAME"
  echo "version: $APPVERSION"
  echo "cat: $APPCAT"
  echo "appdir: $APPDIR"
  echo "lnkdir: $APPLNKDIR"
  echo "bindir: $KDEBINDIR"
  echo -e "-----------------------\n"
fi

# do some last security checks
echo -n "make some security checks ... "
if [ -z $APPUNAME -a]; then
  echo "[failed] (no app unix name in config)"
  exit
elif [ -z $APPDIR ]; then
  echo "[failed] (no app dir in config)"
  exit  
elif [ -z $APPLNKDIR ]; then
  echo "[failed]  (no kmenu link dir in config)"
  exit  
else  
  echo "[OK]"
fi

# decide beteween the commands and change in the kdesu environment
# all dcop info's must be retrieved before this!

case "$CMD" in
"I" )
  kdesu -u $SUDO -d -t -c "bash -c" 'echo "make directories"; mkdir -vp "$APPDIR" && mkdir -vp "$APPLNKDIR" && mkdir -vp "$KDEBINDIR" && echo "copy files"; cp -v $COMMONDIR/$APPUNAME $KDEBINDIR && chmod a+x $KDEBINDIR/$APPUNAME && rm -vf $COMMONDIR/$APPUNAME && cp -v $COMMONDIR/$APPUNAME.desktop $APPLNKDIR/$APPUNAME.desktop && rm -fv $COMMONDIR/$APPUNAME.desktop && cp -rv  $SDIR/* $APPDIR/'
#  if [ -z `echo $PATH | grep "$KDEBINDIR"` ]; then
#    kdialog --msgbox "Installation finished.\n\nThe path\n$KDEBINDIR\nis not in your PATH environment.\nPlease add this path or edit the .desktop files manualy."
#  else
   kdialog --msgbox "Installation finished." 2> /dev/null
#  fi
;;
"U" )
  kdesu -u $SUDO -d -t -c "bash -c" 'rm -vf "$KDEBINDIR/$APPUNAME" && rm -vrf "$APPDIR" && rm -vf "$APPLNKDIR/$APPUNAME.desktop"'
kdialog --msgbox "Uninstallation finished."  2> /dev/null
;;
* )
  kdialog --error "Unknown command!"  2> /dev/null
;;
esac

